package au.com.hothouse.old.admin.bo;

import au.com.hothouse.c1.dao2.db.DateRange;
import au.com.hothouse.c1.dao2.db.advertisers.Template;
import au.com.hothouse.c1.dao2.db.advertisers.TemplateDAO;
import au.com.hothouse.c1.dao2.db.jobboard.Media;
import au.com.hothouse.c1.dao2.db.jobboard.MediaDAO;
import au.com.hothouse.c1.dao2.db.organisation.OrganisationDAO;
import au.com.hothouse.old.admin.forms.CreateTemplatesForm;
import au.com.hothouse.old.util.SearchSpec;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import java.util.Date;
import java.util.List;

/**
 * @deprecated
 */
public class TemplateBO extends BaseBO {

    private TemplateDAO templateDAO = daoLocator.getTemplateDAO();
    private OrganisationDAO organisationDAO = daoLocator.getOrganisationDAO();
    private MediaDAO mediaDAO = daoLocator.getMediaDAO();

    private Log log = LogFactory.getLog(TemplateBO.class);

    public List<Template> searchForTemplates(SearchSpec searchSpec,String templateName, String companyName, String status, DateRange dateRange){
    	
    	return templateDAO.searchTemplates(searchSpec,templateName, companyName, status, dateRange);
    }
    
    public List getCompanyNames(){
    	
    	return organisationDAO.getOrganisations();
    }
    
    public void addTemplate(Template template) {
        log.debug("Enter");
        templateDAO.save(template);
        
    }
    
    public boolean getTemplateProfile(long tempID, CreateTemplatesForm form) {
    	
    	Template temp = templateDAO.findById(tempID);
        if (temp == null)
            return false;

        // Fill out the form info:
        form.setNewProfile(false);
        form.setHeaderLink(null);
        form.setFooterLink(null);
        form.setId(temp.getId());
        form.setTemplateName(temp.getName());
        if(temp.getOrganisation().getId() != null){
        	form.setOrganisationID(temp.getOrganisation().getId().toString());
        }	
        form.setBorderColor(temp.getBordercolour());
        
        if(temp.getStatus() != null && temp.getStatus().equals("Active")){
        	 form.setStatus("false");
		}else{
			form.setStatus("true");
		}	
        
        if(temp.getBorderthickness() != null)
        	form.setBorderThickness(temp.getBorderthickness().toString());

        form.setBorderType(temp.getBorderfull()?"1":"0");
        
        if(temp.getTitlecolour() != null)
        	form.setSubHeadColour(temp.getTitlecolour());
        
        long headerMediaId = 0;
        long footerMediaId = 0;
        
        if(temp.getHeaderid() != null)
        	headerMediaId = temp.getHeaderid();
        
        if(temp.getFooterid() != null)
        	footerMediaId = temp.getFooterid();
        
        Media headerMedia;
        Media footerMedia;
        
        if(headerMediaId > 0){
        	headerMedia = mediaDAO.findById(headerMediaId);
        	form.setHeaderFileName(headerMedia.getName());
        	form.setOldHeaderMediaId(headerMediaId);
        	//System.out.println("Media Footer  "+headerMedia.getDownloadAddress()+":"+headerMedia.getName());
        	
//        	form.setHeaderLink(headerMedia.getDownloadAddress());
        }
        
        if(footerMediaId > 0){
        	footerMedia = mediaDAO.findById(footerMediaId);
        	form.setOldFooterMediaId(footerMediaId);
        	form.setFooterFileName(footerMedia.getName());
        	//System.out.println("Media Footer  "+footerMedia.getDownloadAddress()+":"+footerMedia.getName());
//        	form.setFooterLink(footerMedia.getDownloadAddress());
        	
        }                
        
    	return true;
    }
    
    
    public int countTemplates(SearchSpec searchSpec,String templateName, String companyName, String status, DateRange dateRange){
    	
    	return templateDAO.countTemplates(searchSpec,templateName, companyName, status, dateRange);
    }
    
    
    public String getDownloadAddress(Long mediaID){
    	Media media;
    	if(mediaID !=null && mediaID>0){
    		media = mediaDAO.findById(mediaID);
//    		return media.getDownloadAddress();
    	}
    	
    	return null;
    	
    }
    
    public Template getTemplate(long tempid){
    	return templateDAO.findById(tempid);
	} 
    
    
    public void updateStatus(String[]checks,boolean activate){
    	for (int i = 0; i < checks.length; i++) {
			Template template = templateDAO.findById(new Long(checks[i]));
			template.setLastMod(new Date(System.currentTimeMillis()));
			if (activate) {
				template.setStatus("Active");
			} else {
				template.setStatus("Inactive");
			}
			templateDAO.save(template);
		}
    }
    
}
