
#define _SECURE_SCL	0

#include <stlsoft/util/nulldef.h>

#if 0

# include <recls/cpp/recls.hpp>
# include <recls/cpp/fileentry.hpp>
# include <recls/cpp/filesearch.hpp>
# include <recls/cpp/ftpsearch.hpp>
# include <recls/cpp/search.hpp>

#else

# include <recls/stl/recls.hpp>
# include <recls/stl/root_sequence.hpp>
# include <recls/stl/search_sequence.hpp>
# include <recls/stl/traits.hpp>

#endif

#include <stlsoft/iterators/null_output_iterator.hpp>
#include <stlsoft/obsolete/proxy_iterator.hpp>

#include <algorithm>
#include <iostream>
#include <string>
#include <tchar.h>

#ifdef RECLS_CHAR_TYPE_IS_WCHAR
# define cout	wcout
#else /* ? char type */
# define wcout	cout
#endif /* char type */

int main()
{
#ifdef RECLS_INCL_RECLS_CPP_HPP_FILESEARCH
	reclspp::FileSearch	srch(NULL, NULL, recls::FILES | recls::RECURSIVE);

	for(; srch.HasMoreElements(); srch.GetNext())
	{
		reclspp::FileEntry	entry = srch.GetCurrentEntry();

		std::wcout << entry.File << std::endl;
	}
#endif /* RECLS_INCL_RECLS_CPP_HPP_FILESEARCH */



#ifdef RECLS_INCL_RECLSTL_STL_HPP_SEARCH_SEQUENCE
	reclstl::search_sequence	ss(NULL, NULL, recls::FILES | recls::RECURSIVE);

	std::copy(	ss.begin(), ss.end()
			,	stlsoft::null_output_iterator<reclstl::search_sequence::value_type>());

	for(reclstl::search_sequence::const_iterator b = ss.begin(); b != ss.end(); ++b)
	{
		reclstl::search_sequence::value_type const&	v = *b;

		std::wcout << v.file << std::endl;
	}
#endif /* RECLS_INCL_RECLSTL_STL_HPP_SEARCH_SEQUENCE */


#ifdef RECLS_INCL_RECLSTL_STL_HPP_ROOT_SEQUENCE
	reclstl::root_sequence	rs;

	std::copy(	rs.begin(), rs.end()
			,	stlsoft::null_output_iterator<reclstl::root_sequence::value_type>());
#endif /* RECLS_INCL_RECLSTL_STL_HPP_ROOT_SEQUENCE */

	return 0;
}
