/* /////////////////////////////////////////////////////////////////////////
 * File:        new_params_test.cpp
 *
 * Purpose:     Implementation file for the new_params_test project.
 *
 * Created:     24th March 2007
 * Updated:     22nd April 2007
 *
 * Status:      Wizard-generated
 *
 * License:     (Licensed under the Synesis Software Open License)
 *
 *              Copyright (c) 2007-2007, Synesis Software Pty Ltd.
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au/software
 *
 * ////////////////////////////////////////////////////////////////////// */


/* recls Header Files */
#include <recls/cpp/filesearch.hpp>
#include <recls/implicit_link.h>

/* b64 Header Files */
#include <b64/b64.hpp>
#include <b64/implicit_link.h>


/* STLSoft Header Files */
#include <stlsoft/iterators/string_concatenator_iterator.hpp>

/* PlatformSTL Header Files */
#include <platformstl/platformstl.hpp>

#include <winstl/filesystem/file_functions.hpp>

/* Standard C++ Header Files */
#include <exception>
#include <iostream>
#if 0
#include <algorithm>
#include <iterator>
#include <list>
#endif /* 0 */
#include <set>
#include <string>
#include <vector>

#if !defined(__WATCOMC__) && \
    (   !defined(_MSC_VER) || \
        _MSC_VER >= 1100)

#else /* ? __WATCOMC__ */
namespace std
{
    using ::exception;
}
#endif /* __WATCOMC__ */

/* Standard C Header Files */
#include <stdio.h>
#include <stdlib.h>

#if defined(_MSC_VER) && \
    defined(_DEBUG)
# include <crtdbg.h>
#endif /* _MSC_VER) && _DEBUG */

/* /////////////////////////////////////////////////////////////////////////
 * Macros and definitions
 */


/* /////////////////////////////////////////////////////////////////////////
 * Globals
 */


/* /////////////////////////////////////////////////////////////////////////
 * Typedefs
 */

using stlsoft::byte_t;
typedef std::string				string_t;
typedef std::set<string_t>		stringset_t;
//typedef std::vector<byte_t>		blob_t;
typedef std::vector<string_t>	strings_t;

/* /////////////////////////////////////////////////////////////////////////
 * Forward declarations
 */

static string_t process(char const *root, char const *patterns);

/* ////////////////////////////////////////////////////////////////////// */

static int main_(int /* argc */, char ** /*argv*/)
{
	string_t		s1	=	process("H:\\dev", "*.java");
	string_t		s2	=	process("H:\\dev/*.java", NULL);
	string_t		s3	=	process(NULL, "H:\\dev/*.java");
	string_t		s4	=	process("H:\\dev", "H:\\dev/*.java|*.java");

	if(s1 != s2)
	{
		std::cerr << "s1 != s2" << std::endl;
	}
	else if(s1 != s3)
	{
		std::cerr << "s1 != s3" << std::endl;
	}
	else if(s1 != s4)
	{
		std::cerr << "s1 != s4" << std::endl;
	}

    return EXIT_SUCCESS;
}

int main(int argc, char *argv[])
{
    int             res;

#if defined(_MSC_VER) && \
    defined(_DEBUG)
    _CrtMemState    memState;
#endif /* _MSC_VER && _MSC_VER */

#if defined(_MSC_VER) && \
    defined(_DEBUG)
    _CrtMemCheckpoint(&memState);
#endif /* _MSC_VER && _MSC_VER */

#if 0
    { for(size_t i = 0; i < 0xffffffff; ++i){} }
#endif /* 0 */

    try
    {
#if defined(_DEBUG) || \
    defined(__SYNSOFT_DBS_DEBUG)
        puts("new_params_test: " STLSOFT_COMPILER_LABEL_STRING);
#endif /* debug */

        res = main_(argc, argv);
    }
    catch(std::exception &x)
    {
        fprintf(stderr, "Unhandled error: %s\n", x.what());

        res = EXIT_FAILURE;
    }
    catch(...)
    {
        fprintf(stderr, "Unhandled unknown error\n");

        res = EXIT_FAILURE;
    }

#if defined(_MSC_VER) && \
    defined(_DEBUG)
    _CrtMemDumpAllObjectsSince(&memState);
#endif /* _MSC_VER) && _DEBUG */

    return res;
}

/* ////////////////////////////////////////////////////////////////////// */

static string_t process(char const *root, char const *patterns)
{
	stringset_t	files;
//	blob_t		blob;

	try
	{
		string_t	contents;

		{ for(reclspp::FileSearch	srch(root, patterns, recls::RECURSIVE); srch.HasMoreElements(); srch.GetNext())
		{
			files.insert(srch.GetCurrentEntry().GetPath());
		}}

		{ for(stringset_t::const_iterator b = files.begin(); b != files.end(); ++b)
		{
			strings_t	lines;

			winstl::readlines(*b, lines);

			std::copy(	lines.begin(), lines.end()
					,	stlsoft::string_concatenator(contents, "\n"));
		}}

		return b64::encode(contents.data(), contents.size());
	}
	catch(std::exception &x)
	{
		std::cerr << "Exception: " << x.what() << std::endl;
	}

	return string_t();
}

/* ////////////////////////////////////////////////////////////////////// */
