/* /////////////////////////////////////////////////////////////////////////////
 * File:        recls_stat_test.cpp
 *
 * Purpose:     Implementation file for the recls_stat_test project.
 *
 * Created:     23rd December 2006
 * Updated:     23rd December 2006
 *
 * Status:      Wizard-generated
 *
 * License:     (Licensed under the Synesis Software Open License)
 *
 *              Copyright (c) 2006, Synesis Software Pty Ltd.
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au/software
 *
 * ////////////////////////////////////////////////////////////////////////// */


/* recls Header Files */
#include <recls/cpp/filesearch.hpp>

/* STLSoft Header Files */
#include <stlsoft/stlsoft.h>

/* PlatformSTL Header Files */
#include <platformstl/platformstl.hpp>


/* Standard C++ Header Files */
#include <exception>
#include <iostream>

/* Standard C Header Files */
#include <stdio.h>
#include <stdlib.h>

#if defined(_MSC_VER) && \
    defined(_DEBUG)
# include <crtdbg.h>
#endif /* _MSC_VER) && _DEBUG */

/* ////////////////////////////////////////////////////////////////////////// */

int main(int argc, char *argv[])
{
    if(argc < 2)
    {
        return EXIT_FAILURE;
    }

    try
    {
        using namespace recls::cpp;
        using namespace std;

        FileEntry   entry   =   FileSearch::Stat(argv[1]);

        cout << "full path: " << entry.GetPath() << endl;

        cout << "search-relative path: " << entry.GetSearchRelativePath() << endl;

        cout << "location: " << entry.GetDirectoryPath() << endl;

#ifdef RECLS_PLATFORM_API_WIN32

        cout << "drive: " << entry.GetDrive() << endl;
#endif /* RECLS_PLATFORM_API_WIN32 */

        cout << "directory: " << entry.GetDirectory() << endl;

        cout << "file name+extension: " << entry.GetFile() << endl;

        cout << "file name: " << entry.GetFileName() << endl;

        /// and so on


        if(!entry.IsDirectory())
        {
#ifdef RECLS_PLATFORM_API_WIN32
            // recls_filesize_t is ULARGE_INTEGER

            cout << "size: " << entry.GetSize().LowPart << endl;
#else
            // recls_filesize_t is off_t

            cout << "size: " << entry.GetSize() << endl;
#endif


#ifdef WIN32
            // recls_time_t is FILETIME

            // you have to convert using FileTimeToSystemTime
            FILETIME t1 = entry.GetCreationTime();
            FILETIME t2 = entry.GetModificationTime();
            FILETIME t3 = entry.GetLastAccessTime();
            FILETIME t4 = entry.GetLastStatusChangeTime();
#else
            // recls_time_t is time_t

            // you have to convert using gmtime
            time_t t1 = entry.GetCreationTime();
            time_t t2 = entry.GetModificationTime();
            time_t t3 = entry.GetLastAccessTime();
            time_t t4 = entry.GetLastStatusChangeTime();
#endif



        }

    }
    catch(std::exception &x)
    {
    }

    return 0;
}

/* ////////////////////////////////////////////////////////////////////////// */
